/*
 * Copyright (c) 1998 Kungliga Tekniska Hgskolan
 * (Royal Institute of Technology, Stockholm, Sweden).
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the Kungliga Tekniska
 *      Hgskolan and its contributors.
 * 
 * 4. Neither the name of the Institute nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/* $Id: milko_locl.h,v 1.14 1998/11/10 16:56:05 map Exp $ */

#include "milko.h"

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include <sys/types.h>
#ifdef HAVE_LINUX_TYPES_H
#include <linux/types.h>
#endif
#include <sys/mman.h>
#include <sys/stat.h>
#ifdef HAVE_SYS_DIRENT_H
#include <sys/dirent.h>
#endif
#include <sys/mount.h>
#include <fcntl.h>
#include <netdb.h>
#include <netinet/in.h>
#include <errno.h>
#include <atypes.h>
#include <err.h>
#include <ctype.h>

#include <string.h>
#include <hash.h>
#include <list.h>
#include <assert.h>
#include <unistd.h>
#include <arpa/inet.h>

#include <roken.h>

#include <rx/rx.h>
#include <rx/rx_null.h>

#ifdef KERBEROS
#include <des.h>
#include <krb.h>
#include <rxkad.h>
#endif

/*
 * rx && rxdef && afs related
 */

#include "service.h"
#include "vldb.h"
#include "vldb.ss.h"
#include "volumeserver.h"
#include "volumeserver.ss.h"
#include "fs.h"
#include "fs.ss.h"
#include "pts.h"
#include "afs_dir.h"

#include <volcache.h>
#include <conn.h>
#include <fcache.h>  /* Rights */

/*
 * fileserver and volume
 */

#include "fileserver.h"
#include "volser.h"

/*
 * Buffer handling
 */

#include "mbuf.h"
#include "mdir.h"
#include "bufcache.h"

/*
 *  Filesystems
 */

#include "afsacl.h"

#include "romedia.h"
#include <xfs_message.h>
#include <kafs.h>
#include "fhget.h"

#include "ontop_ff.h"
#include "ontop_subr.h"

/*
 * Defines
 */

#define MILKO_SRVTAB "/etc/srvtab"
